﻿'This application has been programed by Yinon Eliraz

Option Explicit On
Imports Microsoft.DirectX
Imports Microsoft.DirectX.AudioVideoPlayback

Public Class openButton
    Dim Audio As Audio
    Dim Video As Video
    Dim Looping As Boolean = False
    Dim fileName As String

    Private Sub openButton_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If Video IsNot Nothing Then
            Video.Stop()
            Video = Nothing
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ppButton.Text = "Play"
        stButton.Text = "Stop"
        Me.MinimumSize = New Size(GroupBox1.Width + 2, 300)
        stateButton.Visible = False
        pbMini.Visible = False
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        'Sets the generic appearence of the form
        GroupBox1.Top = Me.Height - GroupBox1.Height - SS1.Height - 37
        PictureBox1.Top = 0
        PictureBox1.Left = 0
        GroupBox1.Left = (Me.Width - GroupBox1.Width - 5) / 2
        PictureBox1.Width = Me.Width
        PictureBox1.Height = Me.Height - GroupBox1.Height - SS1.Height - 40
    End Sub


    Private Sub progressBar_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles progressBar.Scroll
        If Video IsNot Nothing Then
            Video.CurrentPosition = progressBar.Value
        End If
    End Sub

    Private Sub updateTmr_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles updateTmr.Tick
        If Video IsNot Nothing Then
            timeLabel.Text = MakeTimeStr(Video.CurrentPosition)
            progressBar.Value = Video.CurrentPosition
            pbMini.Value = Video.CurrentPosition
            If progressBar.Value = progressBar.Maximum Then
                Video.Stop()
                If Looping Then Video.Play()
            End If
        End If
    End Sub

    Private Sub menuOn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuOn.Click
        If Video IsNot Nothing Then
            menuOff.Checked = 0
            menuOn.Checked = 1
            Me.FormBorderStyle = Windows.Forms.FormBorderStyle.None
            Me.Top = 0
            Me.Left = 0
            Me.TopMost = True
            Me.WindowState = FormWindowState.Maximized
            GroupBox1.Visible = False
            PictureBox1.Top = 0
            PictureBox1.Left = 0
            PictureBox1.Width = Me.Width
            PictureBox1.Height = Me.Height - SS1.Height
            stateButton.Visible = True
            pbMini.Visible = True
        End If
    End Sub

    Private Sub menuOff_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles menuOff.Click
        If Video IsNot Nothing Then
            menuOff.Checked = 1
            menuOn.Checked = 0
            stateButton.Visible = False
            pbMini.Visible = False
            Me.FormBorderStyle = Windows.Forms.FormBorderStyle.Sizable
            Me.WindowState = FormWindowState.Normal
            Me.TopMost = False
            GroupBox1.Visible = True
            GroupBox1.Top = Me.Height - GroupBox1.Height - SS1.Height - 35
            PictureBox1.Top = 0
            GroupBox1.Left = (Me.Width - GroupBox1.Width - 5) / 2
            PictureBox1.Width = Me.Width
            PictureBox1.Height = Me.Height - GroupBox1.Height - SS1.Height - 40
        End If
    End Sub

    Private Sub ppMini_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ppMini.Click
        ppButton_Click(sender, e)
    End Sub

    Private Sub stMini_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles stMini.Click
        stButton_Click_1(sender, e)
    End Sub

    Private Sub pbMini_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pbMini.MouseMove
        If e.Button = Windows.Forms.MouseButtons.Left Then
            If e.X > pbMini.Width Then
                pbMini.Value = pbMini.Maximum
            Else
                pbMini.Value = e.X * pbMini.Maximum / pbMini.Width
            End If
            Video.CurrentPosition = pbMini.Value
        End If
    End Sub

    Private Sub pbMini_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pbMini.MouseUp
        If e.Button = Windows.Forms.MouseButtons.Left Then
            If e.X > pbMini.Width Then
                pbMini.Value = pbMini.Maximum
            Else
                pbMini.Value = e.X * pbMini.Maximum / pbMini.Width
            End If
            Video.CurrentPosition = pbMini.Value
        End If
    End Sub

    Private Sub ppButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ppButton.Click
        If FF.Enabled Or RW.Enabled Then 'FF or RW on the movie
            FF.Enabled = False 'Closing them
            RW.Enabled = False
            ffCheck.Checked = False 'Making the visible changes
            rwCheck.Checked = False
            Video.Play() 'Playing the movie again
            ppButton.Text = "Pause" 'Making visible changes
        Else
            If Video IsNot Nothing Then 'A file was loaded
                If Video.Playing Then
                    Video.Pause()
                    ppButton.Text = "Play"
                    stateLabel.Text = "Paused"
                Else
                    Video.Play()
                    ppButton.Text = "Pause"
                    stateLabel.Text = "Playing"
                End If
            Else
                CMD.FileName = ""
                CMD.ShowDialog()
                If CMD.FileName <> "" Then 'Hasnt been cancelled
                    Video = New Video(CMD.FileName) 'Load the file
                    Video.Owner = PictureBox1 'Show in the picturebox
                    Video.Play()
                    Video.Audio.Volume = volBar.Value
                    Form1_Resize(sender, e) 'To adapt the movie to the picturebox
                    ppButton.Text = "Pause"
                    stateLabel.Text = "Playing"
                    progressBar.Maximum = Video.Duration
                    pbMini.Maximum = Video.Duration
                    fileName = CMD.FileName
                    If Len(fileName) > 15 Then
                        nameLabel.Text = Microsoft.VisualBasic.Left(fileName, 15) + "..."
                    Else
                        nameLabel.Text = fileName
                    End If
                    nameLabel.ToolTipText = fileName
                End If
            End If
        End If
    End Sub

    Private Sub openButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        If Video IsNot Nothing Then Video.Pause()
        CMD.FileName = ""
        CMD.ShowDialog()
        If CMD.FileName <> "" Then 'A file has been chosen
            Video = Nothing 'Reset
            Video = New Video(CMD.FileName) 'Load the file
            Video.Owner = PictureBox1 'Play the movie in the picturebox
            Video.Play()
            Video.Audio.Volume = volBar.Value
            Form1_Resize(sender, e) 'Adapt the movie to the picturebox
            ppButton.Text = "Pause"
            stateLabel.Text = "Playing"
            progressBar.Maximum = Video.Duration
            pbMini.Maximum = Video.Duration
            fileName = CMD.FileName
            If Len(fileName) > 15 Then
                nameLabel.Text = Microsoft.VisualBasic.Left(fileName, 15) + "..."
            Else
                nameLabel.Text = fileName
            End If
            nameLabel.ToolTipText = fileName
        Else 'No file has been chosen
            If Video IsNot Nothing Then 'File is in play already
                Video.Play()
                ppButton.Text = "Pause"
            End If
        End If
    End Sub

    Private Sub volBar_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles volBar.Scroll
        If Video IsNot Nothing Then
            Video.Audio.Volume = volBar.Value
        End If
    End Sub

    Private Sub stButton_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles stButton.Click
        If Video IsNot Nothing Then
            Video.Stop()
            stateLabel.Text = "Stopped"
        End If
    End Sub

    Private Sub offLoop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles offLoop.Click
        Looping = False
        offLoop.Checked = True
        onLoop.Checked = False
    End Sub

    Private Sub onLoop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles onLoop.Click
        Looping = True
        offLoop.Checked = False
        onLoop.Checked = True
    End Sub

    Private Sub ffCheck_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ffCheck.CheckedChanged
        rwCheck.Checked = False
        ppButton.Text = "Play"
        If Video IsNot Nothing Then
            If ffCheck.Checked Then
                FF.Enabled = True
            Else
                FF.Enabled = False
                ppButton.Text = "Pause"
            End If
        End If
    End Sub

    Private Sub FF_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FF.Tick
        If Video.CurrentPosition >= Video.Duration - 3 Then 'Reached the end
            ppButton.Text = "Pause"
            FF.Enabled = False
            ffCheck.Checked = False
        Else
            Video.CurrentPosition += 3
        End If
    End Sub

    Private Sub RW_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RW.Tick
        If Video.CurrentPosition <= 3 Then 'Reached the start
            ppButton.Text = "Pause"
            RW.Enabled = False
            rwCheck.Checked = False
        Else
            Video.CurrentPosition -= 3
        End If
    End Sub

    Private Sub rwCheck_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rwCheck.CheckedChanged
        ppButton.Text = "Play"
        ffCheck.Checked = False
        If Video IsNot Nothing Then
            If rwCheck.Checked Then
                RW.Enabled = True
            Else
                ppButton.Text = "Pause"
                RW.Enabled = False
            End If
        End If
    End Sub
End Class
